;PWMt@Rg[[

.include "tn2313def.inc"		
.def	TMPSR	= r15

.def	TMP		= r16
.def	TMPA	= r17

.def	PWMTMP	= r18	;PWM[`Gp
.def	TMR		= r19	;Gp
.def	PWM		= r20	;PWMJE^(Max64)

.def	SPED	= r25	;t@Xs[hۑp
.def	FAN		= r21	;t@o
.def	LEDSP	= r22	;j^[LED
.def	LEDON	= r23	;[^[on/off
;.def	BUZ		= r24	;uU[tO@0=on 

.cseg
	; Interrupt Vectors
		RJMP	reset		;RESET		eؾ
		reti				;EXT_INT0	O荞ݗv0
		reti				;EXT_INT1	O荞ݗv1
		reti				;TIM1_CAPT	/1 ߊl()
		reti				;TIM1_COMPA	/1 rAv
		reti				;TIM1_OVF	/1 ް۰
		rjmp	tim0_ovf	;TIM0_OVF	/0 ް۰
		reti				;USART_RXC	USART M
		reti				;USART_UDRE	USART Mޯ̧
		reti				;USART_TX	USART M
		reti				;ANA_COMP	۸ޔro͑J
		reti				;PCINT		ݕω荞ݗv
		reti				;TIM1_COMPB	/1 rBv
		reti				;TIM0_COMPA	/0 rAv
		reti				;TIM0_COMPB	/0 rBv
		reti				;USI_STRT	USI Jno
		reti				;USI_OVF	USI  ް۰
		reti				;EE_RDY		EEPROM
		reti				;WDT_OVF	ޯތv


;y^C}[0I[o[t[(15.625KHz)z
tim0_ovf:							;
			in		TMPSR , SREG		;SREGޔ

			ldi		PWMTMP, -1				;Reload timer value
			out		TCNT0, PWMTMP			;/

			cp		LEDON, PWM			;
			rol		PWMTMP					;

			cp		LEDSP, PWM			;
			rol		PWMTMP					;

			cp		FAN, PWM			
			rol		PWMTMP				

			out		PORTB, PWMTMP			


			dec		PWM					;PWMfNg
			brne	PC+3				;PWM0łȂPC+3Ń^[
			ldi		PWM, 64				;PWM0,64ŃZbgB

			dec		TMR					;TMRfNgB(15.625KHz/64=244.14Hz=4.09ms)

			out		SREG, TMPSR			;Restore SREG
			reti


;yz

reset:
			ldi		TMP,LOW(RAMEND)		;X^bN|C^
			out		SPL,TMP				;荞ݎgꍇ͕KKv

			ldi		TMP,0b00001111		;PORTB2-4o
			out		DDRB,TMP
	
			ldi		TMP,0b00000000		;PORTDS
			out		DDRD,TMP

			ldi		TMP,0b11111111		;PORTDALLvAbv
			out		PORTD,TMP

;			ldi		TMP,0b00000000
;			out		MCUCR,TMP

			ldi		TMP,0b00000000		;OCR0ʂ̐ݒ
			out		TCCR0A,TMP			;
			ldi		TMP,0x00000011		;64ݒ(1MHz/64=15.625KHz)
			out		TCCR0B,TMP			;

;			ldi		TMP,(1<<INT0)		;O͊݋
;			ldi		TMP,(1<<INT1)		;O͊݋
;			out		GIMSK,TMP

			ldi		TMP,(1<<TOIE0)		;^C}I[o[t[݋
			out		TIMSK,TMP

			ldi		TMP,0b00000000		;^C}[JEg0
			out		TCNT0,TMP

			sei

			ldi		FAN,0			;
			ldi		LEDON,0			;
			ldi		LEDSP,0			;
			ldi		SPED,0			;

main:
;64100ON 0OFF
			mov		FAN,SPED
			mov		LEDON,SPED
			mov		LEDSP,SPED
			ldi		TMR,30
			rcall	delay

			sbis	PIND,3			;upꂽ
			rjmp	up

			sbis	PIND,4			;downꂽ
			rjmp	down

			rjmp	main

up:
			ldi		TMR,1			;`^h~
			rcall	delay
			sbic	PIND,3
			rjmp	main
			inc		SPED
			cpi		SPED,65
			brne	main
			dec		SPED
			rjmp	main				

down:
			ldi		TMR,1			;`^h~
			rcall	delay
			sbic	PIND,4
			rjmp	main
			dec		SPED
			cpi		SPED,-1
			brne	main
			inc		SPED
			rjmp	main				


delay:
			cpi		TMR, 0		;
			brne	PC-1		;
			ret


